import pygame
from pygame.locals import *

import os
from cnst import *

from pgu import engine


class _Score:
    def __init__(self,score,name,data=None):
        self.score,self.name,self.data=score,name,data

def webhighs(value):
    game,a = value
    r = []
    try:
        import socket
        socket.setdefaulttimeout(SOCKET_TIMEOUT)
        import urllib2
        f = urllib2.urlopen(HIGHSURL+"?action=%s&limit=%d"%(a,HIGHS))
        for line in f.readlines():
            score,name,datetimeon = line.split("\t")
            score = int(score)
            r.append(_Score(score,name))
        f.close()
    except:
        import sys,traceback
        e_type,e_value,e_traceback = sys.exc_info()
        print 'Traceback (most recent call last):'
        traceback.print_tb(e_traceback)
        print e_type,e_value
        
    game.data = r
            
class Wait(engine.State):
    def __init__(self,game,fnc,value,next):
        self.game,self.fnc,self.value,self.next = game,fnc,value,next
        
    def init(self):
        self.bkgr = self.game.bkgr
    def paint(self,screen):
        screen.fill((255,255,255))
        img = self.bkgr
        img.set_alpha(128)
        screen.blit(img,(0,0))
        
        #fg = (0xff,0x55,0x55)
        fg = (255,255,255)
        bg = (0,0,0)
        fnt = self.game.font2
        
        y = (SH-36*3)/2
        for line in ['connecting','to server,','please wait...']:
            text = line #self.title
            img = fnt.render(text,1,fg)
            img2 = fnt.render(text,1,bg)
            x = (SW-img.get_width())/2
            screen.blit(img2,(x+2,y+2))
            screen.blit(img,(x,y))
            y += 36
            
        pygame.display.flip()
        
        self.fnc(self.value)
        
        for e in pygame.event.get():
            pass
        
        return self.next
                
def submit(hs):
    try:
        import socket
        socket.setdefaulttimeout(SOCKET_TIMEOUT)
        import urllib2
        import urllib
        f = urllib2.urlopen(HIGHSURL+"?action=submit&score=%d&name=%s"%(hs.score,urllib.quote_plus(hs.name)))
        #yeah, our global high scores go by the "honor system" :) 
    except:
        import sys,traceback
        e_type,e_value,e_traceback = sys.exc_info()
        print 'Traceback (most recent call last):'
        traceback.print_tb(e_traceback)
        print e_type,e_value

                
class Highs(engine.State):
    def __init__(self,game,web=False,title='high scores',parent=None):
        self.game = game
        self.high = self.game.highs
        self.title = title
        self.web = web
        self.parent = parent
            
    def init(self):
        
        #self.game.score = 100
        self.score = None
        if self.game.score != None and self.high.check(self.game.score) is not None:
            self.score = self.high.submit(self.game.score,'')
        self.game.score = None
        self.bkgr = self.game.bkgr
        fnt = self.game.font2
        self.digits = [fnt.render('%d'%n,1,(0,0,0)) for n in xrange(0,10)]
        
        if self.web:
            return Wait(self.game,webhighs,(self.game,self.web),self)


                
    def paint(self,screen):
        if self.web:
            self.high = self.game.data

        screen.fill((255,255,255))
        img = self.bkgr
        img.set_alpha(128)
        screen.blit(img,(0,0))
        
        fg = (0xff,0x55,0x55)
        bg = (0,0,0)
        fnt = self.game.font
        text = self.title
        img = fnt.render(text,1,fg)
        img2 = fnt.render(text,1,bg)
        y = 12
        x = (SW-img.get_width())/2
        screen.blit(img2,(x+2,y+2))
        screen.blit(img,(x,y))

        
        fnt = self.game.font2
        #fnt2 = pygame.font.Font(os.path.join("data","HURRYUP.TTF"),24) #a mono font would be nice
        
        high = self.high
        
        fg = (0,0,0)
        
        x1,x2,x3 = 8,40,SW-8
        y = 80
        for n in xrange(0,min(HIGHS,len(high))):
            if n < len(high):
                hs = high[n]
                name,score =hs.name,hs.score
            else:
                name,score = '',0
                
            c = fg
            #print n,self.score
            if n is self.score:
                c = (255,0x55,0x55)
                name = name+"_"
            
            img = fnt.render("%d."%(n+1),1,c)
            screen.blit(img,(x1,y))
            
            img = fnt.render(name,1,c)
            screen.blit(img,(x2,y))
            
            text = "%d"%score
            
            tw = 14
            x = x3-len(text)*tw
            for c in text:
                img = self.digits[ord(c)-ord('0')]
                screen.blit(img,(x+(tw-img.get_width())/2,y))
                x += tw
            
            #img = fnt2.render("%d"%score,1,c)
            #screen.blit(img,(x3-img.get_width(),y))
            
            y += 25
            
        pygame.display.flip()
        
    def event(self,e):
        if (e.type is KEYDOWN and e.key in (K_RETURN,K_ESCAPE)) or e.type is MOUSEBUTTONDOWN:
            if self.score is None or len(self.high[self.score].name):
                if self.score is not None:
                    self.high.save()
                    return Wait(self.game,submit,self.high[self.score],self.parent)
                return self.parent
        
        if self.score is not None:
            hs = self.high[self.score]
            if e.type is KEYDOWN and e.key == K_BACKSPACE:
                if len(hs.name): 
                    hs.name = hs.name[:-1]
                    self.repaint()
            if e.type is KEYDOWN and (e.key in xrange(K_a,K_z+1) or e.key in (K_MINUS,K_SPACE) or e.key in xrange(K_0,K_9+1)) and len(hs.name) < 12:
                hs.name = hs.name + (e.unicode).encode('latin-1')
                self.repaint()
                
                
                
                
            
        
