import os
import sys

import pygame
from pygame.locals import *

from cnst import *

from pgu import timer
from pgu import engine
from pgu import high

class Sound:
    def __init__(self,fname,vol):
        self.sound = None
        try:
            if pygame.mixer.get_init():
                self.sound = pygame.mixer.Sound(fname)
                self.vol = vol
        except:
            pass
    def play(self):
        if self.sound:
            try:
                if pygame.mixer.get_init():
                    self.sound.set_volume(self.vol)#*Sound.sfx*0.5/100)
                    self.sound.play()
            except:
                pass


class Game(engine.Game):
    def init(self):
        self.timer = timer.Timer(FPS)
        
        try:
            if '-nosound' in sys.argv:
                0/0
            # stop crackling sound on some windows XP machines.
            if os.name == 'posix' or 1:
                try:
                    pygame.mixer.pre_init(44100,-16,2, 1024 * 3)
                except:
                    pygame.mixer.pre_init()
            else:
                pygame.mixer.pre_init()

            pygame.mixer.init()
            print 'mixer initialized'
        except:
            print 'mixer not initialized'
            

        self.screen = pygame.display.set_mode((SW,SH))
        pygame.display.set_caption("elephants - a #ludumdare production")
        
        pygame.font.init()
        
        self.bkgr = pygame.image.load(os.path.join('data','bg.png')).convert()
        
        self.font = pygame.font.Font(os.path.join('data','TORK____.ttf'),48)
        self.font11 = pygame.font.Font(os.path.join('data','TORK____.ttf'),40)
        self.font2 = pygame.font.Font(os.path.join('data','TORK____.ttf'),24)
        
        self.sfx = {}
        for name in [
            'elephant-jump',
            'elephant-pop',
            'elephant-bounce',
            'elephant-giraffe',
            'elephant-spear',
            'elephant-mmove',
            'elephant-mselect',
            'elephant-fall',
            ]:
            self.sfx[name] = Sound(os.path.join('data','%s.wav'%name),1.0)
            
        if pygame.mixer.get_init():
            pygame.mixer.music.load(os.path.join('data','elephant.ogg'))
            pygame.mixer.music.set_volume(0.5)
            pygame.mixer.music.play(-1)
            
        self.high = 0
        self.score = 0
        self.highs = high.High("elephant.hs",HIGHS)
        if len(self.highs) == 0:
            for name in ['trick','DrPetter','philhassey','elephants','squirrels','spears','natives','pgu','cuzco','apples','grass','trees','stuff','things','blah']:
                self.highs.submit(0,name)


            
    def tick(self):
        self.timer.tick()
        

g = Game()
import states
g.run(states.Menu(g))
#import level
#g.run(level.Level(g))

