from distutils.core import setup, Extension
try:
    import py2exe
except:
    pass

import sys
import glob
import os
import shutil

cmd = sys.argv[1]

data = [
    #'*.txt',
    'LICENSE.txt',
    'README.txt',
    'data/*',
    ]

if cmd in ('py2exe',):
    setup(
        options={'py2exe':{
            'dist_dir':'dist',
            'dll_excludes':['_dotblas.pyd','_numpy.pyd']
            }},
        windows=[{
            'script':'main.py',
            #'icon_resources':[(1,'icon64.ico')],
            }],
        )

if cmd == 'py2app':
    from setuptools import setup

    APP = ['galcon.py']
    DATA_FILES = []
    OPTIONS = {'argv_emulation': True, 'iconfile':'galcon.icns'}

    setup(
        app=APP,
        data_files=DATA_FILES,
        options={'py2app': OPTIONS},
        setup_requires=['py2app'],
    )


if cmd in ('py2exe','cx_freeze','py2app'):
    dest = 'dist'
    if cmd == 'py2app': dest = 'dist/LunarChickens.app/Contents/Resources'
    for gname in data:
        for fname in glob.glob(gname):
            dname = os.path.join(dest,os.path.dirname(fname))
            try:
                os.mkdir(dname)
            except:
                'mkdir failed: '+dname
            if not os.path.isdir(fname):
                shutil.copy(fname,dname)

